;----------------------------------------------
; TI-86 flag equates
;----------------------------------------------
; Version 02/02/2000 by Clement Vasseur
; Report any error to <darkclem@wanadoo.fr>

trigFlags			equ	0		;Trigonometry mode settings
trigDeg				equ	2		; 1=degrees, 0=radians

kbdFlags			equ	0		;Keyboard scan
kbdSCR				equ	3		; 1=scan code ready
kbdKeyPress			equ	4		; 1=key has been pressed

DoneFlags			equ	0		;Display "Done"
DonePrgm			equ	5		; 1=display "Done" after Prgm

plotFlags			equ	2		;Plot generation flags
plotLoc				equ	1		; 0=backup & display, 1=display only
plotDisp			equ	2		; 1=plot is in display, 0=text in display

grfModeFlags		equ	2		;Graph mode settings
grfFuncM			equ	4		; 1=function graph
grfPolarM			equ	5		; 1=polar graph
grfParamM			equ	6		; 1=parametric graph
grfRECURM			equ	7		; 1=RECURSION graph

graphFlags			equ	3		;Graphic flags
graphDraw			equ	0		; 0=graph is valid, 1=redraw graph
graphCursor			equ	2		; 0=graph cursor is off, 1=cursor is on

grfDBFlags			equ	4		;Graph format
grfDot				equ	0		; 0=line, 1=dot
grfSimul			equ	1		; 0=sequential, 1=simultaneous
grfGrid				equ	2		; 0=no grid, 1=grid
grfPolar			equ	3		; 0=rectangular, 1=polar coordinates
grfNoCoord			equ	4		; 0=display coordinates, 1=off
grfNoAxis			equ	5		; 0=axis, 1=no axis
grfLabel			equ	6		; 0=off, 1=axis label

textFlags			equ	5		;Text output flags
textEraseBelow		equ	1		; 1=erase line below small char
textScrolled		equ	2		; 1=screen scrolled
textInverse			equ	3		; 1=display inverse bitmap
textInsMode			equ	4		; 0=overstrike, 1=insert mode

parsFlag			equ	6		;Parser flags

parsFlag2			equ	7		;Parser flags
numOP1				equ	0		; 1=result in OP1, 0=no result

;____Flags			equ	8
dxDer				equ	0		; 1=dxNDer, 0=dxDer1

APDFlags			equ	8		;Automatic power-down
APDAble				equ	2		; 1=APD enabled
APDRunning			equ	3		; 1=APD clock running
APDWarmStart		equ	4		; 1=APD has expired

onFlags				equ	9		;ON key flags
onRunning			equ	3		; 1=calculator is running
onInterrupt			equ	4		; 1=ON key interrupt request

fmtFlags			equ	10		;Numeric format flags
fmtExponent			equ	0		; 1=show exponent, 0=no exponent
fmtEng				equ	1		; 1=engineering notion, 0=scientific
fmtHex				equ	2		; 1=hexadecimal
fmtOct				equ	3		; 1=octal
fmtBin				equ	4		; 1=binary
Polarc				equ	5		; 1=polarc
CylV				equ	6		; 1=CylV, set for SphereV also
SphereV				equ	7		; 1=SphereV

curFlags			equ	12		;Cursor flags
curAble				equ	2		; 1=cursor flash is enabled
curOn				equ	3		; 1=cursor is showing
curLock				equ	4		; 1=cursor is locked off

appFlags			equ	13		;Application flags
appTextSave			equ	1		; 1=save characters in textShadow
appAutoScroll		equ	2		; 1=auto-scroll text on last line

asapFlags			equ	15		;ASAP flags
asapQuery			equ	0		; 1=disable installation query

indicFlags			equ	18		;Indicator flags
indicRun			equ	0		; 1=run indicator ON
indicInUse			equ	1		; indicator save area in use=1, free=0
indicOnly			equ	2		; interrupt handler only checks run indicator

shiftFlags			equ	18		;[2nd] and [ALPHA] flags
shift2nd			equ	3		; 1=[2nd] has been pressed
shiftAlpha			equ	4		; 1=[ALPHA] has been pressed
shiftLwrAlph		equ	5		; 1=lower case, 0=upper case
shiftALock			equ	6		; 1=alpha lock has been pressed
shiftKeepAlph		equ	7		; 1=cannot cancel alpha shift

tblFlags			equ	22		;Table flags
tblIndpntAsk		equ	0		; 1=ask table Indpnt

asap_cmd_flag		equ	22		;ASAP command flag
ex_asap_cmd			equ	7

NewDispf			equ	23		;New Display flag???
ProgramExecuting	equ	6		; 1=BASIC program executing

new_grf_flgs		equ	24
textwrite			equ	6

statFlags			equ	29		;Statistics flags
statsvalid			equ	6		; 1=stats are valid

anumeditFlgs		equ	31
ex_asm_module		equ	2

exceptionFlg		equ	35		;Exception flags
alt_font			equ	0		; enable user font (5x7)
alt_sfont			equ	1		; enable user small font
alt_int				equ	2		; enable user interrupt routine
alt_on				equ	3		; enable user on routine
alt_link			equ	4		; enable user link routine
alt_sqrt			equ	5
alt_grphexpr		equ	6		; enable (sqrt)EXPR
alt_off				equ	7		; enable user off routine

exceptionFlg2		equ	36		;Exception flags
alt_parse			equ	0		; enable (sqrt)PARSE
alt_form			equ	1		; enable (sqrt)FORM
alt_exec			equ	2		; enable (sqrt)EXEC
alt_home			equ	4		; enable (sqrt)HOME
alt_cmdtok			equ	5		; enable (sqrt)CMDTOK
alt_key				equ	6		; enable (sqrt)KEY
alt_grf				equ	7		; enable (sqrt)GRF

asm_flag1			equ	40		; unused flags
asm_flag2			equ	41		; for programmers
asm_flag3			equ	42
asm_flag4			equ	43
asm_flag5			equ	44
asm_flag6			equ	45
asm_flag7			equ	46

.end
