;----------------------------------------------
; TI-86 include files for Assembly programming
;----------------------------------------------
; Version 02/02/2000 by Clement Vasseur
; Report any error to <darkclem@wanadoo.fr>

;----------------------------------------------
; Included files
;----------------------------------------------
#include "Asm86.inc"	;ROM calls
#include "Ram86.inc"	;RAM locations
#include "Key86.inc"	;Key equates
#include "Flag86.inc"	;Flags equates
#include "Char86.inc"	;Chars equates
#include "Misc86.inc"	;Misc equates

;----------------------------------------------
; RST equates
;----------------------------------------------
#define rOP1TOOP2		08h
#define rfindsym		10h
#define rPUSHOP1		18h
#define rmov10toop1		20h
#define rFPMULT			28h
#define rFPADD			30h

;----------------------------------------------
; Macros
;----------------------------------------------
#define ld_bc_de			ld b,d\ ld c,e
#define ld_bc_hl			ld b,h\ ld c,l
#define ld_de_bc			ld d,b\ ld e,c
#define ld_de_hl			ld d,h\ ld e,l
#define ld_hl_bc			ld h,b\ ld l,c
#define ld_hl_de			ld h,d\ ld l,e
#define ld_hl_ind			ld a,(hl)\ inc hl \ ld h,(hl)\ ld l,a
#define MoveStack(Src,Dest)	ld hl,Dest-Src\ add hl,sp\ ld sp,hl\ ld hl,Src\ ld de,Dest\ ld bc,256\ lddr
#define Fill(Start,Len,Val)	ld hl,Start\ ld de,Start+1\ ld bc,Len-1\ ld (hl),Val\ ldir
#define Clear(Start,Len)	ld hl,Start\ ld de,Start+1\ ld bc,Len-1\ ld (hl),0\ ldir

.end
