// AsmOutputStream.h: interface for the CAsmOutputStream class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ASMOUTPUTSTREAM_H__44AC2964_A71D_11D3_9AFF_00E658C10A0B__INCLUDED_)
#define AFX_ASMOUTPUTSTREAM_H__44AC2964_A71D_11D3_9AFF_00E658C10A0B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream.h>

class CAssemblyError;

// CAsmOutputStream class
// provides the interface between assembler and caller during assembly.
// the class can be reimplemented or derived from to use the assembler
// in another environment

class CAsmOutputStream
{
public:
	// print a line of text to output
	void PrintInfo(LPCSTR lpszText) const
	{
		LPARAM lParam = (LPARAM)lpszText;
		ASSERT(lParam != NULL);
		CString szMessage( (LPCSTR)lParam);
		cout << (LPCSTR)szMessage;
	}

	// add an error line to output
	void PrintError(CAssemblyError *pError) const
	{	
		CString msg;
		CString filename = pError->m_FileName.Right(pError->m_FileName.GetLength() - pError->m_FileName.ReverseFind('\\') - 1);
		if (pError->m_bWarning)
			msg.Format("Warning #%d in %s, line %d: %s\n", pError->m_ErrCode, filename, pError->m_LineNum, pError->m_Message);
		else
			msg.Format("Error #%d in %s, line %d: %s\n", pError->m_ErrCode, filename, pError->m_LineNum, pError->m_Message);
		cout << (LPCSTR)msg;
	}

	// return TRUE if assembly should be aborted
	BOOL CheckCancel() const
		{ return FALSE; }
};

#endif // !defined(AFX_ASMOUTPUTSTREAM_H__44AC2964_A71D_11D3_9AFF_00E658C10A0B__INCLUDED_)
