// Asmide.cpp : Defines the class behaviors for the application.
//
// Copyright (C) 2000 Jeremy Goetsch (jeremy@acz.org)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include "stdafx.h"
#include "Asmide.h"
#include "TwoPassAsm.h"
#include "OnePassAsm.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAsmideApp construction

CAsmideApp::CAsmideApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CAsmideApp object

//CAsmideApp theApp;

// globally unique identifier
// {71BDB0E9-4257-11D1-8E22-E9E00D4D6E2D}
static const CLSID clsid =
{ 0x71bdb0e9, 0x4257, 0x11d1, { 0x8e, 0x22, 0xe9, 0xe0, 0xd, 0x4d, 0x6e, 0x2d } };

/////////////////////////////////////////////////////////////////////////////
// CAsmideApp initialization

BOOL CAsmideApp::InitInstance()
{

	LoadStdProfileSettings();	// Load standard INI file options (including MRU)
	m_Options.Load();			// Load program options

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// Global functions

CString GetDirFromPath( CString path)
{
	return( path.Left( path.ReverseFind('\\') + 1));
}

CString GetFNameFromPath( CString path)
{
	return( path.Mid( path.ReverseFind('\\') + 1));
}

BOOL CheckFileExt( LPCSTR szPathName, LPCSTR szExt)
{
	return (strlen(szPathName) > 4 && !stricmp(szPathName + strlen(szPathName) - 4, szExt));
}

// change working dir to path of executable
//  returns pointer to previous working dir (valid until next call to SetDirDefault)
LPCSTR SetDirDefault()
{
	static char szPrevDir[MAX_PATH];
	char szExePath[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, szPrevDir);
	GetModuleFileName(NULL, szExePath, _MAX_PATH);
	*(strrchr(szExePath, '\\') + 1) = '\0';
	SetCurrentDirectory(szExePath);
	return szPrevDir;
}

// create a directory and all parent directories
BOOL CreateFullDirectory(LPCSTR lpPathName)
{
	if (!CreateDirectory(lpPathName, NULL) && GetLastError() != ERROR_ALREADY_EXISTS) {
		if (!CreateFullDirectory(GetDirFromPath(lpPathName)))
			return FALSE;
		if (!CreateDirectory(lpPathName, NULL))
			return FALSE;
	}
	return TRUE;
}

// Dialog data validation functions

static char szInvalidChars[] = "*?\"<>|";
