// Asmide.h : main header file for the ASMIDE86 application
//
// Copyright (C) 2000 Jeremy Goetsch (jeremy@acz.org)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#if !defined(AFX_ASMIDE86_H__71BDB0EE_4257_11D1_8E22_E9E00D4D6E2D__INCLUDED_)
#define AFX_ASMIDE86_H__71BDB0EE_4257_11D1_8E22_E9E00D4D6E2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include "Options.h"
//#include "Project.h"

/////////////////////////////////////////////////////////////////////////////
// Private messages

// output window messages
#define WM_USER_ADD_ERROR		(WM_APP + 1)
#define WM_USER_PRINT_LINE		(WM_APP + 2)
#define WM_USER_CLEAR_OUTPUT	(WM_APP + 3)

#define WM_USER_ASM_BEGIN		(WM_APP + 4)
#define WM_USER_ASM_DONE		(WM_APP + 5)

#define WM_USER_MULTIUNDO		(WM_APP + 6)
#define WM_USER_MULTIREDO		(WM_APP + 7)

/////////////////////////////////////////////////////////////////////////////
// CAsmideApp:
//
/*
class CAsmideCommandLine : public CCommandLineInfo
{
public:
	CAsmideCommandLine() {m_bBuildFlag = FALSE;}
	virtual void ParseParam(LPCTSTR pszParam,BOOL bFlag,BOOL bLast);

	BOOL m_bBuildFlag;
};
*/
class CAsmideApp : public CWinApp
{
public:
	CAsmideApp();
	//BOOL ProcessAsmCommand( CAsmideCommandLine& rCmdInfo );

	const COptionsStor *GetOptions() const { return &m_Options; }
	//CProject *GetProject() { return &m_Project; }


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAsmideApp)
	public:
	virtual BOOL InitInstance();
/*	virtual int ExitInstance();
	virtual BOOL OnIdle(LONG lCount);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual BOOL SaveAllModified();
	virtual CDocument* OpenDocumentFile(LPCTSTR lpszFileName);
*/	//}}AFX_VIRTUAL


protected:
	COptionsStor m_Options;
/*
	CProject m_Project;

	//{{AFX_MSG(CAsmideApp)
	afx_msg void OnAppAbout();
	afx_msg void OnRevalidate86p();
	afx_msg void OnToolsOptions();
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	afx_msg void OnExternalTool(UINT nID);
	afx_msg void OnUpdateExternalTool(CCmdUI* pCmdUI);
	afx_msg void OnHelpWebLink(UINT nID);
	DECLARE_MESSAGE_MAP()
*/
};

// global functions
CString GetDirFromPath( CString path);
CString GetFNameFromPath( CString path);
LPCSTR SetDirDefault();
BOOL CreateFullDirectory(LPCSTR lpPathName);
BOOL CheckFileExt( LPCSTR szPathName, LPCSTR szExt);
//void WINAPI DDV_FileNameValid(CDataExchange* pDX, CString const& filename);
//void WINAPI DDV_FileExists(CDataExchange* pDX, CString const& filename);

// Global pointer to options structure
inline const COptionsStor *GetOptions()
{
	return ((CAsmideApp *)AfxGetApp())->GetOptions();
}
/*
// Global pointer to current project structure
inline CProject *GetProject()
{
	return ((CAsmideApp *)AfxGetApp())->GetProject();
}
*/
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ASMIDE86_H__71BDB0EE_4257_11D1_8E22_E9E00D4D6E2D__INCLUDED_)
