// OnePassAsm.h: interface for the one-pass assembler classes
//
// Copyright (C) 2000 Jeremy Goetsch (jeremy@acz.org)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#if !defined(AFX_ONEPASSASSEMBLER_H__D85D49E7_9067_11D3_9AFF_D03B57C11707__INCLUDED_)
#define AFX_ONEPASSASSEMBLER_H__D85D49E7_9067_11D3_9AFF_D03B57C11707__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Assembler.h"

//////////////////////////////////////////////////////////////////////
// COnePassAssembler - base class for one-pass assembly operations

class COnePassAssembler : public CAssembler  
{
public:
	COnePassAssembler(UINT nFlags, LPCSTR szDefines = NULL);
	virtual void Build( CString filename);

protected:
	virtual void Output(CString filename) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// CStatsAssembler - Show the assembly statistics dialog
/*
class CStatsAssembler : public COnePassAssembler  
{
public:
	CStatsAssembler(UINT nFlags, LPCSTR szDefines = NULL);

protected:
	virtual void Output(CString filename);
};
*/

/////////////////////////////////////////////////////////////////////////////
// CSymTableAssembler - Write include file

class CSymTableAssembler : public COnePassAssembler
{
public:
	CSymTableAssembler(UINT nFlags, LPCSTR szDefines = NULL);

protected:
	virtual void Output(CString filename);
};

#endif // !defined(AFX_ONEPASSASSEMBLER_H__D85D49E7_9067_11D3_9AFF_D03B57C11707__INCLUDED_)
