// TwoPassAsm.h: interface for two-pass assembler derived classes.
//
// Copyright (C) 2000 Jeremy Goetsch (jeremy@acz.org)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#if !defined(AFX_HEXASSEMBLER_H__D85D49E8_9067_11D3_9AFF_D03B57C11707__INCLUDED_)
#define AFX_HEXASSEMBLER_H__D85D49E8_9067_11D3_9AFF_D03B57C11707__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Assembler.h"

/////////////////////////////////////////////////////////////////////////////
// CTwoPassAssembler - base class for two-pass assembly

class CTwoPassAssembler : public CAssembler
{
public:
	CTwoPassAssembler(UINT nFlags, LPCSTR szDefines = NULL);
	virtual void Build( CString filename);

protected:
	virtual void Output(CString filename, CMemFile& fData) = 0;
};

/////////////////////////////////////////////////////////////////////////////
// CPluginAssembler - Standard assembler (uses output plugin)

class CPluginAssembler : public CTwoPassAssembler
{
public:
	CPluginAssembler(UINT nFlags, LPCSTR szPlugin, LPCSTR szDefines = NULL);

protected:
	virtual void Output(CString filename, CMemFile& fData);
};


/////////////////////////////////////////////////////////////////////////////
// CHexAssembler - Output a hex listing

class CHexAssembler : public CTwoPassAssembler  
{
public:
	CHexAssembler(UINT nFlags, LPCSTR szDefines = NULL);

protected:
	virtual void Output(CString filename, CMemFile& fData);
};

#endif // !defined(AFX_HEXASSEMBLER_H__D85D49E8_9067_11D3_9AFF_D03B57C11707__INCLUDED_)
