#include <windows.h>
#pragma hdrstop
#include <winuser.h>
#include <condefs.h>
#include <stdio.h>
#include <dir.h>

//-----------------------------------------------------------------------=
----
//   Important note about DLL memory management in a VCL DLL:
//
//
//
// If your DLL uses VCL and exports any functions that pass VCL String =
objects
// (or structs/classes containing nested Strings) as parameter or =
function
// results, you will need to build both your DLL project and any EXE =
projects
// that use your DLL with the dynamic RTL (the RTL DLL).  This will =
change your
// DLL and its calling EXE's to use BORLNDMM.DLL as their memory =
manager. In
// these cases, the file BORLNDMM.DLL should be deployed along with your =
DLL
// and the RTL DLL (CP3240MT.DLL). To avoid the requiring BORLNDMM.DLL =
in
// these situations, pass string information using "char *" or =
ShortString
// parameters and then link with the static RTL.
//
//-----------------------------------------------------------------------=
----
USEDEF("asm83p.def");
//-----------------------------------------------------------------------=
----
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}

extern "C" const char *GetPluginDescription();
extern "C" void About();
extern "C" int SavePrgmFile(unsigned char *pData, unsigned nLength, =
const char *szFilename, char *szExt);

__declspec(dllexport) const char *GetPluginDescription()
{
	return "TT-83+ assembly program (.8xp)";
}

__declspec(dllexport) void About()
{
	MessageBox(NULL,
		"8XP file export for Ti-83+ assembly\n"
		"Assembly Studio plugin\n"
		"Written by Rusty Wagner",
		"About asm83p.dll", MB_OK);
}

__declspec(dllexport) int SavePrgmFile(unsigned char *pData, unsigned =
nLength, const char *szFilename, char *szExt)
{
	FILE *fp;
	char name[256];
    int i,csum;

	strcpy(name,szFilename);
	strcat(name,".8xp");
	if ((fp=3Dfopen(name,"wb"))=3D=3DNULL)
		return 0;
    fprintf(fp,"**TI83F*");
    fputc(0x1a,fp); fputc(0xa,fp); fputc(0,fp);
    fprintf(fp,"File generated by Asm83p.dll");
    for (i=3D0;i<14;i++)
        fputc(0,fp);
    fputc((nLength+0x15)&0xff,fp);
    fputc((nLength+0x15)>>8,fp);
    fputc(0xd,fp); fputc(0,fp);
    csum=3D0xd;
    fputc((nLength+4)&0xff,fp);
    fputc((nLength+4)>>8,fp);
    csum+=3D((nLength+4)&0xff)+(((nLength+4)>>8)&0xff);
    fputc(6,fp);
    csum+=3D6;
    fnsplit(szFilename,NULL,NULL,name,NULL);
    int nameLen=3Dstrlen(name);
    if (nameLen>8) nameLen=3D8;
    for (i=3D0;i<nameLen;i++)
    {
        char c=3Dname[i];
        if ((c>=3D'a')&&(c<=3D'z'))
            c+=3D'A'-'a';
        fputc(c,fp);
        csum+=3Dc&0xff;
    }
    for (;i<8;i++)
        fputc(0,fp);
    fputc(1,fp); fputc(0,fp);
    csum++;
    fputc((nLength+4)&0xff,fp);
    fputc((nLength+4)>>8,fp);
    csum+=3D((nLength+4)&0xff)+(((nLength+4)>>8)&0xff);
    fputc((nLength+2)&0xff,fp);
    fputc((nLength+2)>>8,fp);
    csum+=3D((nLength+2)&0xff)+(((nLength+2)>>8)&0xff);
    fputc(0xbb,fp); fputc(0x6d,fp);
    csum+=3D0xbb+0x6d;
	for(i=3D0;i<nLength;i++)
	{
        fputc(pData[i],fp);
        csum+=3DpData[i];
	}
    fputc(csum&0xff,fp);
    fputc(csum>>8,fp);
	fclose(fp);
	if (szExt!=3DNULL)
		strcpy(szExt,".8xp");
	return 1;
}